extern Image posTexture;
extern Image velTexture;
attribute float SpriteCount;
attribute float PointCorner;

extern vec2 translation;
extern vec2 particle_uv[20];

extern float particleCountSQRT;
extern mat4 cameraViewMat;
extern mat4 cameraTransformMat;
extern mat4 modelMat;
extern float zPos;

varying vec4 vLookup;
varying vec4 pLookup;

const float PI = 3.141592;
const float PI2 = 3.141592*2;

float scale_factor = 2000;

vec4 position( mat4 transform_projection, vec4 vertex_position )
{
	// get the position of the current sprite out of the position texture
	vec2 lookup_uv = vec2(mod(SpriteCount,particleCountSQRT)*1.0/particleCountSQRT+1/512.0, floor(SpriteCount/particleCountSQRT)/particleCountSQRT+1/512.0);
	pLookup = Texel(posTexture, lookup_uv);
	vLookup = Texel(velTexture, lookup_uv);

	pLookup.rg += translation;

	float size = sin(pLookup.a*3.14) * 15;

	if(pLookup.a <= 0.01)
	{
		size = 0;
	}

	vertex_position = vec4(1,1,1,1);
	vertex_position.xy = pLookup.rg*love_ScreenSize.rg - size*0.5;

	VaryingColor = vec4(pLookup.a*0.8, pLookup.a*0.5, 0.2-pLookup.a*0.2, VaryingColor.a);
	
	//rotate vertex
	float rot = vLookup.b*PI2;//1.57;
	float half_size = 0;
	float half_sizex = 0;
	float half_sizey = 0;

	vec2 origin = pLookup.rg*love_ScreenSize.rg - size*0.5;

	int vertCount = int(PointCorner);
	
	size = size * 0.5;
	
 	if(vertCount == 0)
	{
		vertex_position.y -= size;
	}
	if(vertCount == 1){
		vertex_position.y -= size;
	}

	if(vertCount == 1 || vertCount == 2){
		
		vertex_position.x += size * (1 + (abs(vLookup.x)*scale_factor+abs(vLookup.y)*scale_factor));
		VaryingTexCoord.x = 1;
	}

	if(vertCount == 2 || vertCount == 3){
		vertex_position.y += size;
		VaryingTexCoord.y = 1;
	}

	vec2 v = vertex_position.xy;
	v = v + -origin.xy;
	v = mat2(cos(rot), -sin(rot), sin(rot), cos(rot)) * v;
	v = v + origin.xy;

	vertex_position.xy = v.xy;
		
	//try to rotate here

	half_size = 0.5;//width of an individual particle on the texture
	
	vec2 uv = VaryingTexCoord.xy;//*half_size;
	
	uv = uv*half_size + particle_uv[0];

	VaryingTexCoord.xy = uv.xy;
	
  return transform_projection*vertex_position;
}
